#include<bonnet.h>

void make_partition_table(int no,int sec_start,int sec_count)
{
	struct pentry *pe;
	char buf[512];
	char *ptr;

	pe = (struct pentry *)malloc(sizeof(struct pentry));
	pe->flag = 0;
	pe->start = 0;
	pe->sys_flag = 131;
	pe->end = 0;
	pe->rel = sec_start;
	pe->nsec = sec_count;

	sread(0,buf,1);
	ptr = &buf[446 + (no-1)*16];
	memcpy(ptr,pe,sizeof(struct pentry));
	swrite(0,buf,1);
}

void make_super_block()
{
	struct ext2_super_block sb;

	sb.s_inodes_count = 256;
	sb.s_blocks_count = 512;
	sb.s_r_blocks_count = 50;
	sb.s_free_blocks_count = 509;
	sb.s_free_inodes_count  = 253;
	sb.s_first_data_block = 0;
	sb.s_log_block_size = 2; // 4096
	sb.s_log_frag_size = 2;
	sb.s_blocks_per_group = 512;
	sb.s_frags_per_group = 512; 
	sb.s_inodes_per_group = 256;
	sb.s_mtime = 0;
	sb.s_wtime = 0;
	sb.s_mnt_count = 0;
	sb.s_max_mnt_count = 0;
	sb.s_magic = 0;
	sb.s_state = 0;
	sb.s_errors = 0;
	sb.s_minor_rev_level = 0;
	sb.s_lastcheck = 0;
	sb.s_checkinterval = 0;
	sb.s_creator_os = 0;
	sb.s_rev_level = 0;
	sb.s_def_resuid = 0;
	sb.s_def_resgid = 0;

	sb.s_first_ino = 0;
	sb.s_inode_size = 128;
	sb.s_block_group_nr = 0;
	sb.s_feature_compat = 0;
	sb.s_feature_incompat = 0;
	sb.s_feature_ro_compat = 0;
	strcpy(sb.s_volume_name,"bonnet");
	sb.s_algorithm_usage_bitmap = 0;
	sb.s_prealloc_blocks = 0;
	sb.s_prealloc_dir_blocks = 0;

	swrite(2,&sb,2); // offset 1024 ~ 2048
}

void make_block_desc()
{
	struct ext2_group_desc gd;

	gd.bg_block_bitmap = 2;        /* Blocks bitmap block */
	gd.bg_inode_bitmap = 3;        /* Inodes bitmap block */
	gd.bg_inode_table  = 4;     /* Inodes table block */
	gd.bg_free_blocks_count = 256;   /* Free blocks count */
	gd.bg_free_inodes_count = 512;   /* Free inodes count */
	gd.bg_used_dirs_count   = 1; /* Directories count */

	swrite(8,&gd,1); // 1 block 
}

void format_drive()
{
	make_partition_table(4,0,2048);
	make_super_block();
	make_block_desc();
	//make_blocks_bitmap();
	//make_inodes_bitmap();
	//make_inodes_table();
	//make_data_block();
}
